local BAH = {
	Version = "7.3.170830",
	UpdateTime = "2017-08-30 11:00:00",
	LoadedAddons = {},
	Debug = true,
	Color = {
        red = {1,0,0},
        green = {0,1,0},
        blue = {0,0,1},
        yellow = {1,1,0}
	},Data = {
		Name = "",
		Server = nil
	},Player = {
		DefaultText="#input id[-server]!",
		EditBox = nil,
		Switch = nil
	},Print = function(self,message,color)
		if not color then color = "green"; end;
		if message == "#" then message = "#------------------------------------------------------#\n"; end
		DEFAULT_CHAT_FRAME:AddMessage(message, self.Color[color][1], self.Color[color][2], self.Color[color][3], 1, 5);
	end,Log = function(self,message)
		if self.Debug then self:Print(message,"yellow"); end;
	end
};
function BAH.Player:New()
	self.EditBox = CreateFrame("EditBox", "EditBoxPlayer", UIParent,"InputBoxTemplate");
	self.EditBox:SetText(self.DefaultText);
	self.EditBox:SetMaxLetters(50);
	self.EditBox:SetPoint("CENTER", 0, -150);
	self.EditBox:SetHeight(32);
	self.EditBox:SetWidth(200);
	self.EditBox:Disable();
	self.EditBox:SetScript("OnMouseDown",function(self,button) self:Enable(); if self:GetText() == BAH.Player.DefaultText then self:SetText(""); end end);
	self.EditBox:SetScript("OnLeave",function(self,motion) if self:GetText() == "" then self:SetText(BAH.Player.DefaultText); end self:Disable();  end);
	self.Switch = CreateFrame("EditBox", "EditBoxSwitch", UIParent,"InputBoxTemplate");
	self.Switch:SetJustifyH("CENTER");
	self.Switch:SetSize(32,32);
	self.Switch:SetPoint("CENTER", 120, -150);
	self.Switch:Disable();
	self.Switch:SetScript("OnMouseDown",function(self,button)
		if self:GetText()=="ON" then
			BAH_ENABLED = "OFF"
			self:SetTextColor(1,0,0,1);
			BAH.Player.EditBox:Hide();
		else
			BAH_ENABLED = "ON"
			self:SetTextColor(0,1,0,1);
			BAH.Player.EditBox:Show();
		end
		self:SetText(BAH_ENABLED);
	end);
	if BAH_ENABLED=="OFF" then
		self.Switch:SetText("OFF");
		self.Switch:SetTextColor(1,0,0,1);
		self.EditBox:Hide();
	else
		self.Switch:SetText("ON");
		self.Switch:SetTextColor(0,1,0,1);
	end
end
function BAH.Player:IsEnabled()
	if self.Switch:GetText()=="ON" then
		return true;
	else
		return false;
	end
end
function BAH.Player:GetInfo()
	local name = self.EditBox:GetText();
	if not self:IsEnabled() or name == "" or name == self.DefaultText then
		return "",nil;
	else
		if string.find(name,"-") then
			return string.split("-",name);
		else
			return name,nil;
		end
	end
end
function BAH_OnEvent(self,event,...)
    local argv = ...;
	if event == "ADDON_LOADED" then
		if argv == "BijiaqiAH" then
			if not BAH.LoadedAddons[argv] then
				BAH.LoadedAddons[argv] = true;
				BAH:Print("[BijiaqiAH]verision:"..BAH.Version.."!\n");
				BAH.Player:New();
			end
		elseif argv == "Blizzard_AuctionUI" then
			if not BAH.LoadedAddons[argv] then
				BAH.LoadedAddons[argv] = true;
				BAH:Print("'id[-server]@item name' search item name for id\n");
				local AuctionFrameBrowse_Search_old = AuctionFrameBrowse_Search;
				local AuctionFrameBrowse_Update_Old = AuctionFrameBrowse_Update;
				AuctionFrameBrowse_Search = function()
					local ItemName = BrowseName:GetText();
					if string.find(ItemName,'@') then
						ItemName = loadstring('return "'..ItemName..'"')();
						local id = string.gsub(ItemName,"@.*","");
						BAH.Data.Name,BAH.Data.Server = string.split("-",id);
						if BAH.Data.Server then
							BAH.Data.Server = BAH.Data.Name.."-"..BAH.Data.Server;
						end
						BrowseName:SetText(string.gsub(ItemName,".*@",""));
						SortAuctionItems("list", "quantity");
						SortAuctionItems("list", "buyout");
						SortAuctionItems("list", "buyout");
					else
						local name,server = BAH.Player:GetInfo();
						if name ~= "" then
							BAH.Data.Name,BAH.Data.Server = name,server;
							if BAH.Data.Server then
								BAH.Data.Server = BAH.Data.Name.."-"..BAH.Data.Server;
							end
						end
					end
					BAH.Data.Loaded = true;
					AuctionFrameBrowse_Search_old();
				end;
				AuctionFrameBrowse_Update = function()
					AuctionFrameBrowse_Update_Old();
					local total  = 0;
					local count  = GetNumAuctionItems("list");
					local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame);
					for i = 1,count do
						local name,_,count,_, _, _,_,_,_,buy,_,_,_,owner,server =  GetAuctionItemInfo("list", i);
						if owner then
							local find = false;
							if string.upper(owner) == string.upper(BAH.Data.Name) and server == BAH.Data.Server then
								find  = true;
								total = total+1;
							end
							if i>offset and i<(offset+NUM_BROWSE_TO_DISPLAY) and find then
								local item = getglobal("BrowseButton" .. (i-offset) .. "Name");
								item:SetFormattedText("[ BijiaqiAH ] \n        %s", item:GetText() or "");
							end
						end
					end
					if BAH.Data.Loaded and BAH.Data.Name ~= "" then
						BAH.Data.Loaded = false;
						BAH:Print("version:"..BAH.Version..",search for "..BAH.Data.Name.."'s total:"..total);
					end
				end
			end
		end
    elseif event=="TRADE_SHOW" then
		local name,server = BAH.Player:GetInfo();
		if BAH.Player:IsEnabled() then
			if name == "" then
				CancelTrade();
				BAH:Print("#","red");
				BAH:Print("  Pls input id or id-server or click 'ON'!","red");
				BAH:Print("#","red");
			else
				local _name,_server = UnitName("NPC");
				if name==_name and server == _server then
					BAH:Print("  ['"..name.."'".."=='".._name.."'] is correct!["..BAH.Version.."]","green");
				else
					CancelTrade();
					BAH:Print("#","red");
					BAH:Print("  Trade has been cancelled","red");
					BAH:Print("  This character'"..name.."' probably is a scammer","red");
					BAH:Print("#","red");
				end
			end
		end
    end
end
BAH_Frame = CreateFrame("Frame");
BAH_Frame:SetScript("OnEvent", BAH_OnEvent);
BAH_Frame:RegisterEvent("ADDON_LOADED");
BAH_Frame:RegisterEvent("TRADE_SHOW");